import bodyParser from "body-parser";
import express from "express";
import http from "http";
import morgan from "morgan";
import sourceMapSupport from "source-map-support";
import WebSiteService from "../application/WebSiteService";
import routes from "./routeREST";

export default class RESTServer {

    public port: number;
    public webSiteService: WebSiteService;

    constructor(port, webSiteService) {
        this.port = port;
        this.webSiteService = webSiteService;
    }

    public start() {
        // Create server
        const app = express();
        const port = process.env.PORT || this.port;
        const server = http.createServer(app);

        // logger

        if (process.env.NODE_ENV === "development") {
            app.use(morgan("combined"));
            sourceMapSupport.install();
        }

        // attach routes
        app.use((req, res, next) => {
            res.setHeader("Access-Control-Allow-Origin", "*");
            res.setHeader("Access-Control-Allow-Methods", "GET, POST");
            res.setHeader("Access-Control-Allow-Headers", "X-Requested-With,content-type");
            res.setHeader("Access-Control-Allow-Credentials", true);
            next();
        });

        // request parser
        app.use(bodyParser.json({limit:'50MB'}));
        
        app.use(bodyParser.urlencoded({ extended: true }));

        // WebSite route
        routes(app, this.webSiteService);

        // Start server
        server.listen(port, () => {
            // tslint:disable-next-line: no-console
            console.log("server is listening on port", this.port);
        });

    }

}
